/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : main.c
 *       Abstract    : Sample Program Main
 *       Version     : 1.03.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History   : May.13.2009 ver.1.00.00
 *                 : Jul.06.2009 ver.1.01.00 Changed common directory
 *                 : Jul.13.2009 ver.1.02.00 Tool-Chain 9.2.0.0
 *                 : Nov.10.2009 ver.1.03.00 Changed common directory
 *""FILE COMMENT END""**********************************************************/
#include <stdio.h>
#include <string.h>
#include <machine.h>
#include <mathf.h>
#include "iodefine.h"       /* SH7264 iodefine  */
#include "m3a_hs64.h"
#include "usb.h"
#include "usb_firm.h"
#include "common.h"




#ifdef FORMAT_1702 
/*  1M [16(1M=64Kx16)
--------------------------
 space 128k  Read 192k/288k(1702format)   Data0[0] / Data0[8]
 --------------------------
 ch1 DMA 192k                        Data0[2]/ Data0[10]
---------------------
 ch2 DMA 192k                        Data0[5]/ Data0[13]
----------------------------
- */
#endif

#pragma section CDATA
  unsigned long Data0[16][ SSI_DATASIZE0 /4];  
#pragma section



unsigned int BuffIdx0,BuffIdx_bulkin,BuffIdx_bulkin_old;  
unsigned int BuffIdx3,BuffIdx_bulkin3,BuffIdx_bulkin3_old; 
unsigned int l_SSI_DATASIZE;
int x_state0;
#define  STATE_STOP 1
#define  STATE_START 2
#define  STATE_PLAY 3

/* {TvOĐtO */
int double_speed0;

/* NSSI3 ́@USBRg[̐؂ւPB22XCb`ōsB*/
int USB_INPUT0;

/*   AUDIO CLOCK ؂ւtO */
int  audio_clk0;

/* continue mode flag */
unsigned char  cont_flag0;
#define  CONT_MODE0 1

/* ==== vg^Cv錾 ==== */
void init_ssif(void);
int  change_ssi2_bck();
void io_init_dma1(void *src, void *rsrc, void *dst, void *src2, void *dst2, void *rdst2, void *src3, void *rsrc3, void *dst3);
void set_data0(void);
void set_ssi(void);
void check_bulkin();
void mem_irekae(unsigned char *p);
void init_i2c(void);
int init_lcd(void);
int test_lcd_puts(unsigned char *s1, unsigned char *s2);
unsigned char *return_file_name0(int track0);
void test_num2char0( int x0, unsigned char *p0);
#ifdef USE_I2C0
void lcd_test1(void);
int test_lcd_icon(int code0);
#endif

/* For  UART IO  *****************************************************************/
char io_getchar(void);
void io_putchar(char c);
char io_getchar(void);
int io_recvcheck(void);

/* Global Wav File **************************************************************/
int file_size_all;
int file_size_data;
short nChannels; 
int nSamplesPerSec; 
short wBitsPerSample; 

int  track0;

extern void sci_printf (char* str, ...);

/**************************/
extern unsigned char Stat;
extern unsigned char s_IsMediumConnect;
extern unsigned char s_CheckDir;
/* Disk Status Bits (DSTATUS) */
// #define STA_NOINIT		0x01	/* Drive not initialized */
// #define STA_NODISK		0x02	/* No medium in the drive */
// #define STA_PROTECT		0x04	/* Write protected */
#ifndef TRUE
 #define TRUE           1
#endif
#ifndef FALSE
 #define FALSE          0
#endif

extern int scan_files_ff2(void);
extern int fopen_fatfs(int Fileth);
extern void fclose_fatfs(void);
extern int fread_fatfs(char *pd0, int c1);

extern int WAV_FILE_5ff;

/*""FUNC COMMENT""*******************************************************
 * Outline     : main
 *-----------------------------------------------------------------------
 * Include     : 
 *-----------------------------------------------------------------------
 * Declaration : void main(void);
 *-----------------------------------------------------------------------
 * Description : 
 *-----------------------------------------------------------------------
 * Argument    : void
 *-----------------------------------------------------------------------
 * Return Value: void
 *-----------------------------------------------------------------------
 * Notice      : 
 *""FUNC COMMENT END""***************************************************/
 

void main(void)
{	
	unsigned char c;
        unsigned short value0,value0_state;
        int vcount0,value1,ack0;

        
#define NO_INPUT_STATE 99
#define DURATION0    10000          
        

      

        /* AUDIO CLK pɃ}`vbNXݒ */
        PORT.PECR0.BIT.PE0MD	= 2;	/* AUDIO CLK */
        audio_clk0=0;  // when 1, audio clk

        x_state0=STATE_STOP;

        /* PB21 ɒǉLED̐̂߂̏ݒ */
		/* ƕt^ɂƂƂĂLED̐̂߂̏ */
		/* PG14ɒǉLED̐̂߂̏ݒ  */
	    /*--- PBCR5ݒ PB21̐ݒ ---*/	
	    PORT.PBCR5.WORD &= 0xFF0Fu;
	    PORT.PCCR2.WORD &= 0xFFF0u;
#ifdef YLED0
	    PORT.PGCR3.WORD &= 0xF0FFu;
#endif
    	/*--- PBIOR1ݒ PB21LEDo͂ɐݒ ---*/
	     PORT.PBIOR1.WORD |= 0x0020u;
	     PORT.PCIOR0.WORD |= 0x0100u;
#ifdef YLED0
	     PORT.PGIOR0.WORD |= 0x4000u;
#endif	
     	/*--- PBDR1ݒ PB21Low ---*/
     	     
        PORT.PCDR0.BYTE.H &= 0xFEu;  //t^ɂƂƂĂLED_ 
        PORT.PBDR1.BYTE.L &= 0xDFu;   /* LED@ */
        /////PORT.PBDR1.BYTE.L |= 0x20u;     /* LED@ */
#ifdef YLED0
		PORT.PGDR0.BYTE.H &= 0xBFu;
                PORT.PGDR0.BYTE.H &= 0xBFu; // FLED@_			
		/////PORT.PGDR0.BYTE.H |= 0x40u;	// FLED@
#endif

#ifdef PB22_INPUT		
		/* PB22̓|[gɐݒ */
		 PORT.PBCR5.WORD &= 0xF0FFu;
		 PORT.PBIOR1.WORD &= 0x003Fu;
                 PORT.PGDR0.BYTE.H |= 0x40u;	
#endif	

#ifdef USE_ADC_INPUT0
                PORT.PHCR0.WORD = 0x1111;   /* set H port as AD */
                ADC.ADCSR.WORD = 0x0000;    /* single mode */
                ADC.ADCSR.BIT.ADST = 1;     /* A/D start ... */
                value0_state=NO_INPUT_STATE ;
                value1=-1;
#endif


                /* 2{TvOĐǂ */
		 double_speed0=0;
		 
#ifdef PB22_INPUT		 
		 if( (PORT.PBPR1.WORD & 0x0040u) != 0) USB_INPUT0=1;
		 else USB_INPUT0=0;
#else
         USB_INPUT0=1;		 
#endif
	  
    	/* f[^̏  */
		set_data0();
     
       /*-- DMAC ̏ݒ ---- */
       /*  SSI2M   SSI3M   SSI1M  */
       BuffIdx0 = 0u;	   
       BuffIdx3 = 0u;
       io_init_dma1( Data0[2], Data0[10], (void *)&SSIF2.SSIFTDR,  (void *)&SSIF3.SSIFRDR, Data0[10], Data0[2],   Data0[5], Data0[13], (void *)&SSIF1.SSIFTDR);
       
       /*-- SSI ̏ݒ ---- */ 
       init_ssif();	   
	   
	   
       /* fatfs p̏ */
       s_IsMediumConnect=FALSE;
       cont_flag0=FALSE;

	
	/* USB HOST̏ */
        H_ModeInit();

        /* VAȍ */
        io_init_scif0();


        sci_printf("*test program\n");

#ifdef USE_I2C0
         init_i2c();   
         ack0=init_lcd(); 
         if( ack0 != 0)  sci_printf(" init lcd error %d\n",ack0);
         
#endif

/**********************************************************************
  t^ɂƂƂĂLED @~͓_APLAÝ@bulkin ؂ւɓ_
@LED́@[ݏI_BDMA1]IɏB
@LED́@[ݏI_BDMA3]IɏB

***********************************************************************/
        
	while(1)
	{


#ifdef USE_ADC_INPUT0
                if( ADC.ADCSR.BIT.ADF == 1)  /* ADC finish */
                ////if( ADC.ADCSR.BIT.ADST == 0)  /* ADC finish */
                {
                   ADC.ADCSR.BIT.ADF=0;   // flag clear
                   value0= ADC.ADDRA.WORD;
                   value0 = value0 >> 6; 
                   value1= (int)value0;   // for debug use only

                    /* 10bit 1024 */
                   if( value0 < 80 )   /* center 16.4% */
                   {  value0=0; }
                   else if( value0 < 226)  /* center 32.4% */
                   {   value0=1;}
                   else if( value0 < 410)  /* center 47% */
                   {   value0=2;}
                   else if( value0 < 542)  /* center 60% */
                   {   value0=3;}
                   else
                   {   value0=NO_INPUT_STATE ; }     /* no input state */

                  
                   if( value0 != NO_INPUT_STATE )
                   {
                      if( value0 == value0_state)
                      {
                         vcount0++;
                         if( vcount0 == DURATION0)  /* ADlK񐔁@lɂȂƂ */
                         {
                            switch( value0)
                            {
                               case 0: /* letter small p */
                                     fopen_fatfs( track0 ); 
                                     x_state0=STATE_START;
                                     //fclose_fatfs();
#ifdef USE_I2C0
                                     lcd_test1();
                                     test_lcd_icon(1);  
#endif
                                     break;
                               case 1: /* letter small e*/
                                     x_state0=STATE_STOP;
                                     fclose_fatfs();
                                     PORT.PCDR0.BYTE.H &= 0xFEu;   //t^ɂƂƂĂLED_ 
#ifdef USE_I2C0  
                                     test_lcd_icon(0);
#endif                                  
                                     set_data0();
                                     break;
                               case 2: /* letter small b */
                                     track0--; 
                                     if(track0 < 0) track0=0;
                                     ////sci_printf("track=%d\n",track0);
#ifdef USE_I2C0
                         lcd_test1();
#endif
                                     break;
                               case 3: /* letter small n */
                                     track0++; 
                                     if(track0 >= WAV_FILE_5ff) track0= WAV_FILE_5ff-1;
                                     ////sci_printf("track=%d\n",track0);    
#ifdef USE_I2C0
                         lcd_test1();
#endif                                
                                     break;
                            }
						 }
                      }
                      else
                      {   
                         /* value0 ̒lωƂ */
                         value0_state = value0;
                         vcount0=0;
                      }
                   }
                   else
                   {
                      value0_state=NO_INPUT_STATE;
                      vcount0=0;
                   }

                   ADC.ADCSR.BIT.ADST = 1;     /* A/D start ... */
                }
#endif


		/* VAGR[obN̏ */
		if( io_recvcheck() != 0 ) 
                {
                   c = (unsigned char) io_getchar();						/*PM */
		   if (c > 0)
		   {
			io_putchar(c);		/*PM */
		   }
                   
                    switch(c)
                    {
                        case 0x64: /* letter small d */ /* for debug */
                            sci_printf(" BuffIdx0 = %d,  BuffIdx3=%d \n", BuffIdx0, BuffIdx3);
                            sci_printf(" DMAC.DMATCR1 = %d,  DMAC.DMATCR3=%d \n",  DMAC.DMATCR1.LONG, DMAC.DMATCR3.LONG);
                            break;
                        case 0x73: /* letter small s */
                            scan_files_ff2(); 
                            break;
                        case 0x65: /* letter small e */
                            x_state0=STATE_STOP;
                            fclose_fatfs();
                            PORT.PCDR0.BYTE.H &= 0xFEu;   //t^ɂƂƂĂLED_ 
#ifdef USE_I2C0  
                            test_lcd_icon(0);
#endif    
                           set_data0();
		            break;
            case 0x6e: /* letter small n */
                            track0++; 
                            if(track0 >= WAV_FILE_5ff) track0= WAV_FILE_5ff-1;
                            sci_printf("track=%d\n",track0);
                            break;
                       case 0x62: /* letter small b */
                            track0--; 
                            if(track0 < 0) track0=0;
                            sci_printf("track=%d\n",track0);
                            break;
                        case 0x70: /* letter small p */
                              fopen_fatfs( track0 ); 
                              x_state0=STATE_START;
                              //fclose_fatfs();
#ifdef USE_I2C0
                         lcd_test1();
                         test_lcd_icon(1);
#endif
                              break;  
                       case 0x61: /* letter small a */
                            sci_printf("AD value=%d\n",value1);
#ifdef USE_I2C0
                             ack0 = test_lcd_puts("test1", "test2");
                            if( ack0 != 0) sci_printf("test_lcd_puts error %d\n",ack0);
#endif
                            break;                                                
                       default:
                            if( (c >= 0x30) && (c <= 0x39))  /* letter 0 to 9  */
                            {
                              fopen_fatfs( (int)(c - 0x30)); 
                              x_state0=STATE_START;
                              //fclose_fatfs();
                              break;
                            }
                            
                            
                   }

                }


#ifdef CONT_MODE0 
                if( cont_flag0 == TRUE)
                {
                    cont_flag0= FALSE;

                    track0++; 
                    if(track0 <= (WAV_FILE_5ff-1)) 
                    { 
                           fopen_fatfs( track0 ); 
                           x_state0=STATE_START;
                           //fclose_fatfs();
#ifdef USE_I2C0
                         lcd_test1();
                         test_lcd_icon(1);
#endif                       
                        sci_printf("track=%d\n",track0);
                    }else track0= WAV_FILE_5ff-1;
                    
                }

#endif
		/* USBzXg */
		H_main();
		
		/* USBڑAt@Čs */
		if( s_IsMediumConnect && ( s_CheckDir == FALSE) ) 
		{ 
			scan_files_ff2(); 
			s_CheckDir= TRUE;
#ifdef USE_I2C0
                        lcd_test1();  
#endif


		}

                if( x_state0==STATE_START)
                {
                  
                  PORT.PCDR0.BYTE.H |= 0x01u; //t^ɂƂƂĂLED 
                  
                  set_ssi();
                 /*  BuffIdx Zbg */
                  BuffIdx_bulkin=BuffIdx0;
                  BuffIdx_bulkin3=BuffIdx3;
                  BuffIdx_bulkin_old=BuffIdx_bulkin;	
                  BuffIdx_bulkin3_old=BuffIdx_bulkin3;
                 
                 x_state0=STATE_PLAY;
                }
                else if( x_state0==STATE_PLAY)
                {
                  check_bulkin();
                }
 
	}





}

//-----------------------------------------------------------------
void check_bulkin()
{
       unsigned char *p;
       unsigned int count0;

           /*  bulkin ؂ւ */

#ifdef FORMAT_1702
           if(  (BuffIdx_bulkin_old != BuffIdx_bulkin) && ( BuffIdx_bulkin3_old != BuffIdx_bulkin3))
	    {	
  	        BuffIdx_bulkin_old   = BuffIdx_bulkin;
                BuffIdx_bulkin3_old  = BuffIdx_bulkin3;

#else
           if(  BuffIdx_bulkin_old != BuffIdx_bulkin) 
	    {	
  	        BuffIdx_bulkin_old=BuffIdx_bulkin;
#endif


	       PORT.PCDR0.BYTE.H &= 0xFEu;   //t^ɂƂƂĂLED_ 

#ifdef  FORMAT_1702              
               p=(unsigned char *)Data0[8 * BuffIdx_bulkin]; 
#else
               p=(unsigned char *)Data0[8 * BuffIdx_bulkin]; 
#endif
               count0=fread_fatfs((char *)p, l_SSI_DATASIZE);
               if( count0 != l_SSI_DATASIZE)
               {
                  sci_printf("Error count0 != l_SSI_DATASIZE \n");
                  x_state0=STATE_STOP;
                  fclose_fatfs();
                  PORT.PCDR0.BYTE.H &= 0xFEu;   //t^ɂƂƂĂLED_ 

#ifdef USE_I2C0  
                  test_lcd_icon(0);
#endif    
                  set_data0();

#ifdef CONT_MODE0 
                  cont_flag0=TRUE;
#endif
	       }
               else
               {
                   /* [̔zu̓ւ */
                   mem_irekae(p);

               }


	        PORT.PBDR1.BYTE.L &= 0xDFu;   /* LED@ */
#ifdef FORMAT_1702			
 #ifdef YLED0			
		PORT.PGDR0.BYTE.H &= 0xBFu; // FLED@_	
 #endif
#endif
            	PORT.PCDR0.BYTE.H |= 0x01u; //t^ɂƂƂĂLED 

            }//if(  BuffIdx_bulkin_old != BuffIdx_bulkin) 


}

//-----------------------------------------------------------------
void mem_irekae(unsigned char *p)
{
     int i;
     int *in0,*out0;
     char *pin;
     char c0;
  union  ux2b
  {
    int  l0;
    char c0[4];
  } uic2b,ux2c;


#ifdef FORMAT_1702

#define DAC_BIT_NUMBER 20   // 1702 20, 1704 24, 61p 18 

     pin=(char *)p; pin+=(l_SSI_DATASIZE-1);
     in0=(int *)(p+ SSI_DATASIZE0 * 5 - 4);
     out0=(int *)(p+ SSI_DATASIZE0 * 8 - 4);

     for(i=0;i<SSI_DATASIZE2;++i)
     {
        /* ch2*/
        ux2c.l0=0;
        ux2c.c0[0]= *pin--;
        ux2c.c0[1]= *pin--;
        if( wBitsPerSample == 24) ux2c.c0[2]= *pin--;
        *out0=ux2c.l0>>(32 - DAC_BIT_NUMBER);  
        out0--;

       /* ch1 */
       uic2b.l0=0;
       uic2b.c0[0]= *pin--;
       uic2b.c0[1]= *pin--;
       if( wBitsPerSample == 24) uic2b.c0[2]= *pin--;
       *in0=uic2b.l0>>(32 - DAC_BIT_NUMBER);
       in0--;

     }

#else
    /* ------------------------------------------------------ */
  #ifdef I2S_24BIT
     pin=(char *)p; pin+=(l_SSI_DATASIZE-1);
     out0=(int *)(p+ SSI_DATASIZE0 * 8 - 4);
     for(i=0;i<SSI_DATASIZE2W;++i)
     {
        ux2c.l0=0;
        ux2c.c0[0]= *pin--;
        ux2c.c0[1]= *pin--;
        if( wBitsPerSample == 24) ux2c.c0[2]= *pin--;
        *out0=ux2c.l0;
        out0--;
     }

  #else
    in0=(int *)p; 
    pin=(char *)p
    if( wBitsPerSample == 24) // 3btye
    {
       /* 3byte -> 2byte */
       for(i=0;i<SSI_DATASIZE22;++i)
       {
           ++pin;
           ux2c.c0[1]=*pin++;
           ux2c.c0[0]=*pin;
           *pin=+2;
           ux2c.c0[3]=*pin++;
            ux2c.c0[2]=*pin;
           *in0++ =ux2c.l0;

           pin+=2;
           ux2c.c0[1]=*pin++;
           ux2c.c0[0]=*pin;
           *pin=+2;
           ux2c.c0[3]=*pin++;
           ux2c.c0[2]=*pin;
           *in0++ =ux2c.l0;
      }
    }
    else
    {   // big little henkan
       for(i=0; i< SSI_DATASIZE2; ++i)
       {
           uic2b.l0=in0[i];

           c0=uic2b.c0[0];
           uic2b.c0[0]=uic2b.c0[1];
           uic2b.c0[1]=c0;

           c0=uic2b.c0[2];
           uic2b.c0[2]=uic2b.c0[3];
           uic2b.c0[2]=c0;

           in0[i]=uic2b.l0;
       }
    }

 #endif   //  #ifdef I2S
#endif


}

//-----------------------------------------------------------------
void set_ssi(void)
{
  int c0;

  switch( nSamplesPerSec)
  {
      case  48000:
             audio_clk0=1;
             double_speed0=0;
             break;
      case  96000:
             audio_clk0=1;
             double_speed0=2;
             break;
      case 192000:
             audio_clk0=1;
             double_speed0=4;
             break;
      case 88200:
             audio_clk0=0;
             double_speed0=2;
             break;
      case 176400:
             audio_clk0=0;
             double_speed0=4;
             break;
      default:  // 44100
             audio_clk0=0;
             double_speed0=0;
  }

  switch(wBitsPerSample)
 {
    case 24:

          l_SSI_DATASIZE = SSI_DATASIZE3;   // 192k(3/2) =288k
          break;
    default:  // 16bit
          l_SSI_DATASIZE= SSI_DATASIZE;    // 192kbtype
 }

            //ēx
       c0=change_ssi2_bck();
       sci_printf("SSI RETRY %d\n",c0);
}
//--------------------------------------------------------------------

/* DMA1 p@SSI2@ւ̑M荞ݏ@*/
void io_int_dma1(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RSAR1.LONG= (unsigned long)Data0[2+ 8 *BuffIdx0]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
 
#ifdef I2S_24BIT
        DMAC.RDMATCR1.LONG= SSI_DATASIZE2W ;
#else
        DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;
#endif

 
	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin=BuffIdx0;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx0 ^= 1u;
	 
	  
	  
	  /*--- PBDR1ݒ PB21High ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L |= 0x20u;
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR1.BIT.TE = 0u;
      dummy = DMAC.CHCR1.BIT.TE; /* _~[[h */



}

#ifdef FORMAT_1702
void io_int_dma3(void)
{
     volatile unsigned long dummy;	 
	 

	  /* SSI1p DMA3 ][hݒ */
      DMAC.RSAR3.LONG= (unsigned long)Data0[5+ 8 * BuffIdx3]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
     


	    DMAC.RDMATCR3.LONG= SSI_DATASIZE2 ;

 
	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin3=BuffIdx3;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx3 ^= 1u;
	 
	  
	  
	  /*--- ݒ  ---*/		
         // FLED@	
	 PORT.PGDR0.BYTE.H |= 0x40u;	
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR3.BIT.TE = 0u;
      dummy = DMAC.CHCR3.BIT.TE; /* _~[[h */



}
#endif







void set_data0(void)
{
   unsigned long i;

   for(i=0;i<SSI_DATASIZE2;++i)
   {
	   Data0[2][i]=0;
	   Data0[5][i]=0;
	   Data0[10][i]=0;
           Data0[13][i]=0;
   }


}

/****************************************************************************/
#ifdef USE_I2C0
void lcd_test1(void)
{
                   unsigned char *pt0,cnum0[4];
				   int ack0;
                    if( WAV_FILE_5ff <= 0)
                    {
                             ack0 = test_lcd_puts("", "no file");
                            if( ack0 != 0) sci_printf("test_lcd_puts error %d\n",ack0);
                    }
                    else
                    {
                     pt0= return_file_name0(track0);
                     test_num2char0( (track0+1), cnum0);
                            ack0 = test_lcd_puts(cnum0, pt0);
                            if( ack0 != 0) sci_printf("test_lcd_puts error %d\n",ack0);
                    }
                            
}
#endif
/* End of File */
