/*""FILE COMMENT""**************************************************************
*
*       System Name : SH7670 USB Sample Program
*       File Name   : h_main.c
*       Contents    : Host Sample Program Main
*       Version     : 2.01.00
*       Model       : M3A-HS71
*       CPU         : SH7670
*       Compiler    : SHC9.1.1.0
*       OS          : none
*
*       note        :
*                     <ӎ>
*                     {TvvOׂ͂ĎQlłA
*                     ̓ۏ؂̂ł͂܂B
*                     {TvvO͂ql̃\tgEGAJ
*                     ZpQlƂĂp
*
*       The information described here may contain technical inaccuracies or
*       typographical errors. Renesas Technology Corporation and Renesas Solutions
*       assume no responsibility for any damage, liability, or other loss rising 
*       from these inaccuracies or errors.
*
*       Copyright (C) 2008 Renesas Technology Corp. All Rights Reserved
*       AND Renesas Solutions Corp. All Rights Reserved
*
*       history   : 2008.01.09 ver.1.00.00 
*                 : 2008.01.17 ver.2.00.00 
*                 : 2008.09.02 ver.2.01.00 
*""FILE COMMENT END""*********************************************************/

/* ==== include file ==== */
#include <string.h>
#include <stdlib.h>
#include "..\inc\usb_firm.h"
#include "usb.h"

#include "../../common.h"


/* ==== prottype ==== */
extern void sci_printf (char* str, ...);
extern int test_lcd_puts(unsigned char *s1, unsigned char *s2);

extern unsigned char Stat_FatFs;
extern unsigned char s_IsMediumConnect;
extern unsigned char s_CheckDir;
extern int track0;
extern unsigned char cont_flag0;

/* Disk Status Bits (DSTATUS) */
#define STA_NOINIT		0x01	/* Drive not initialized */
#define STA_NODISK		0x02	/* No medium in the drive */
#define STA_PROTECT		0x04	/* Write protected */
#ifndef TRUE
 #define TRUE           1
#endif
#ifndef FALSE
 #define FALSE          0
#endif

/*******************************************/
int send_cbw_a(int code0, unsigned char *dat, unsigned int addrs, unsigned char count0);

/*""FUNC COMMENT""************************************************************ 
* ID         : 
* Outline    : Host mode Sample Main
*----------------------------------------------------------------------------- 
* Include    : 
*----------------------------------------------------------------------------- 
* Declaration: void H_main(void);
*----------------------------------------------------------------------------- 
* Function   : 
*            : 
*----------------------------------------------------------------------------- 
* Argument   : void
*----------------------------------------------------------------------------- 
* ReturnValue: void
*----------------------------------------------------------------------------- 
* Notice     : 
*            : 
*""FUNC COMMENT END""*********************************************************/
void H_main(void)
{
	static		detach_device = 0;
	USB_U16		device_state,speed;
    unsigned char            dat8[1];  // dummy data

	device_state = H_GetUsbDeviceState();
	if( device_state == DVST_DETACHED ){
		if(detach_device == 0){
			/* sci_printf( "\n" ); */
			sci_printf( "+Detach Port\n" );
			/* sci_printf( "\n" ); */
#ifdef USE_I2C0
                        test_lcd_puts("detach", "");
#endif
			detach_device = 1;

                        /* for fatfs */
                        Stat_FatFs= STA_NOINIT | STA_NODISK;
                        s_IsMediumConnect= FALSE;
						s_CheckDir= FALSE;
                                                cont_flag0= FALSE;

                        /*  PIPE CLEAR ??? */
                       
		}
	}
	else{
		if(detach_device == 1){
			/* sci_printf( "\n" ); */
			sci_printf( "-Attach Port\n" );
			/* sci_printf( "\n" ); */
			detach_device = 0;
#ifdef USE_I2C0
                        test_lcd_puts("attach", "");
#endif
                        /* for fatfs */
                        Stat_FatFs= STA_NOINIT;
		}
	}

	switch( device_state ){
	case DVST_DEFAULT:
		speed = usb_is_hispeed();
		if( speed == HI_SPEED ){
			sci_printf( "+Hi-Speed Device\n" );
			/* sci_printf( "\n" ); */
		}
		else if( speed == FULL_SPEED ){
			sci_printf( "+Full-Speed Device\n" );
			/* sci_printf( "\n" ); */
		}
		else if( speed == LOW_SPEED ){
			sci_printf( "+Low-Speed Device\n" );
			/* sci_printf( "\n" ); */
		}
		else{
			sci_printf( "-Error Device\n" );
			/* sci_printf( "\n" ); */
		}
		break;

	case DVST_ADDRESS:
#ifdef DEG34B
		sci_printf( "USB Address is %d----\n", UsbAddress );
		/* sci_printf( "\n" ); */
		/* sci_printf( "\n" ); */
#endif
		break;

	case DVST_SET_PIPE:
		print_getconf_device_end( PIPE_DONE );
		print_getconf_config_end( PIPE_DONE );
		break;

	default:
		break;
	}

	if( device_state == DVST_CONFIGURED ) {

		// zXgǉ
               if( s_IsMediumConnect== FALSE)
               {
 
                if( send_cbw_a(0, dat8,0,0) == -7)
                {
                   // one more try  !
                   usb_delay_xms(100);
                   send_cbw_a(0, dat8,0,0);
                 }
                 send_cbw_a(1, dat8,0,0);
                 send_cbw_a(2, dat8,0,0);
                 send_cbw_a(3, dat8,0,0);  
                 s_IsMediumConnect = TRUE; track0=0;
               }

	}

}
/*===========================================================================*/


/* ==== }N` ==== */
int  BULK_OUT_PIPE = PIPE1;
int  BULK_IN_PIPE = PIPE2;

int H2F_start_snd( unsigned long size, unsigned char *top );
int H2F_start_rcv( unsigned long size, unsigned char *buf );
int H2F_check_complete( unsigned short Pipe );
extern unsigned short  s_bytes_per_sector;  /* bytes per sector */
extern unsigned int    s_bytes_per_block;   /* bytes per block */
extern unsigned int    s_max_lba;           /* max logical block address */
extern unsigned int    s_DbrOffset;  /* offset of dbr */




/*  [eʂ炷߁Aȉ{̂蕪    */
#ifdef USE_RCV_BUF 

#define RCV_BUFSIZE		512
void H2F_snd_char(unsigned char c);
int H2F_rcv_buffercheck(void);  /* VKǉ */
unsigned char H2F_rcv_char(void);
/* Mobt@ i[oCgێϐ(O[oϐ) */
static int rsz = 0;
static unsigned char buf[RCV_BUFSIZE];
static int idx = 0;
static int recvcheck = 0;	/* M`FbNXe[gϐ(VKǉ) */




/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : 1oCgM
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : void H2F_snd_char(unsigned char c);
*----------------------------------------------------------------------------- 
* Description : oNIN]gpāA1oCgf[^USBt@NVɑM܂B
*             : MɌĂяoɖ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned char c : I ; Mf[^
*----------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
void H2F_snd_char(unsigned char c)
{
	H2F_start_snd( 1, &c );
	while( !(H2F_check_complete(BULK_OUT_PIPE)) ){
		/* wait */
	}
}


/*************************************/
/* CDC Recv buffer check (VKǉ)  */
/*************************************/
int H2F_rcv_buffercheck(void)
{
	if (recvcheck == 0) {
		if ( rsz <= 0 ) {
			/* MJn */
			if( H2F_start_rcv( RCV_BUFSIZE, buf ) == 0 ){
				recvcheck = 1;
			}
			return 0;
		} else {
			return rsz;
		}

	} else {
		/* MmF */
		if (H2F_check_complete(BULK_IN_PIPE)){
			/* M */
			rsz = RCV_BUFSIZE - USBDataCount[ BULK_IN_PIPE ];
			idx = 0;
			recvcheck = 0;
			return rsz;
		} else {
			return 0;
		}
	}
}


/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : 1oCgM
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : unsigned char H2F_rcv_char(void);
*----------------------------------------------------------------------------- 
* Description : oNOUT]gpUSBt@NVf[^M܂B
*             : Mf[^ꍇ͎Mf[^1oCgAĂяoɕԂ܂B
*             : Mf[^Ȃꍇ͖{֐ő҂܂B
*             : zXg畡oCg̃f[^MꍇɑΉ邽
*             : }bNXpPbgTCY(HS:512byte, FS:64byte)܂ł͂܂Ƃ߂ĎM
*             : Ė{֐ŗpӂobt@ɒ~ςĂ܂B
*----------------------------------------------------------------------------- 
* Argument    : void
*----------------------------------------------------------------------------- 
* Return Value: Mf[^(G[̏ꍇ0xFFԂ)
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
unsigned char H2F_rcv_char(void)
{
	unsigned char c;
	
	/* ==== Mς݃f[^Ȃꍇ́AMĎM҂ ==== */
	while( rsz <= 0 ){
		if( H2F_start_rcv( RCV_BUFSIZE, buf ) < 0 ){
			return 0xFF;
		}
		while( !(H2F_check_complete(BULK_IN_PIPE)) ){
			/* wait */
		}
		rsz = RCV_BUFSIZE - USBDataCount[ BULK_IN_PIPE ];
		idx = 0;
	}
	/* ==== obt@Mf[^ 1oCgo ==== */
	c = buf[ idx++ ];
	rsz--;
	return c;
}


#endif


/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int H2F_start_snd( unsigned long size, unsigned char *top );
*----------------------------------------------------------------------------- 
* Description : oNIN]gpāAŎw肳ꂽf[^TCY̑M
*             : f[^USBzXgt@NVɑM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *top : I ; Mf[^̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int H2F_start_snd( unsigned long size, unsigned char *top )
{
	USB_U16		buffer;
	USB_U16 	pipe = BULK_OUT_PIPE;


	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
		return -1;
	}
	/* ---- MJnioNIN]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_send_transfer(pipe, size, top);
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int H2F_start_rcv( unsigned long size, unsigned char *buf );
*----------------------------------------------------------------------------- 
* Description : oNOUT]gpāAŎw肳ꂽf[^TCY̎M
*             : f[^USBt@NVM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *buf : O ; Mobt@̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int H2F_start_rcv( unsigned long size, unsigned char *buf )
{
	USB_U16		buffer;
	USB_U16 	pipe = BULK_IN_PIPE;
	
	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
	
		return -1;
	}
	/* ---- MJnioNOUT]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_recieve_transfer( pipe, size, buf );
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : ]̊mF
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int H2F_check_complete( unsigned short pipe );
*----------------------------------------------------------------------------- 
* Description : Ŏw肵pCv̓]Ăꍇ́A]Ԃ܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned short pipe : I ; pCvԍ
*----------------------------------------------------------------------------- 
* Return Value: 1 : ]
*             : 0 : ] ܂ STALL/G[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int H2F_check_complete( unsigned short pipe )
{
	if( (PipeFlag[pipe] == PIPE_IDLE) || (PipeFlag[pipe] == PIPE_DONE) ){
		return 1;
	}
	return 0;
}




/* End of File */

/*===========================================================================================*/
unsigned char cbw_testUnitReady_00[]=
{ 0x55, 0x53, 0x42, 0x43, 0x74, 0x74, 0x79, 0x72,
  0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x06, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

unsigned char cbw_inquiry_01[]=
{ 0x55, 0x53, 0x42, 0x43, 0x74, 0x74, 0x79, 0x73,
  0x24, 0x00, 0x00, 0x00, 0x80, 0x00, 0x06, 0x12,
  0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };


unsigned char cbw_ReadCapacity_02[]=
{ 0x55, 0x53, 0x42, 0x43, 0x74, 0x74, 0x79, 0x74,
  0x08, 0x00, 0x00, 0x00, 0x80, 0x00, 0x0a, 0x25,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };


unsigned char cbw_Read10_03[]=
/* 1 block, 512 btytes */
{ 0x55, 0x53, 0x42, 0x43, 0x74, 0x74, 0x79, 0x75,
  0x00, 0x02, 0x00, 0x00, 0x80, 0x00, 0x0a, 0x28,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

unsigned char cbw_Read10_04[]=
/* e͐B*/
{ 0x55, 0x53, 0x42, 0x43, 0x74, 0x74, 0x79, 0x76,
  0x00, 0x02, 0x00, 0x00, 0x80, 0x00, 0x0a, 0x28,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

union  ux
{
    unsigned int  l0;
    unsigned char c0[4];
} uic0;


int send_cbw_a(int code0, unsigned char *dat8, unsigned int addrs, unsigned char count0)
{
        #define BUFFER_SIZEx01 36  // for cbw_inquiry response
        #define BUFFER_SIZEx02 8  //  for ReadCapacity response
        #define BUFFER_SIZEx03 512  //  for cbw_Read10_03
        #define SIZE_OF_CSW 13
         

                       /* TCY@512+1@ĝŁ@X^bNI[o[ɒӁI@*/ 
        unsigned char p[BUFFER_SIZEx03+ 1];  //<---ԑ傫ȗ̈Ő錾邱ƁBA> SIZE_OF_CSW
        int l,i,size0;
        int BUFFER_SIZEx0;
        unsigned char *p1,*p2;
        int rt0=0;



        switch( code0 )
        {
           case 0:
               BUFFER_SIZEx0 =0;
               p1= cbw_testUnitReady_00;
               p2=p;
#ifdef DEG34
               sci_printf( "+send_cbw testUnitReady \n" );
#endif
               break;
           case 1:
               BUFFER_SIZEx0 = BUFFER_SIZEx01;
               p1= cbw_inquiry_01;
               p2=p;
#ifdef DEG34
               sci_printf( "+send_cbw inquiry \n" );
#endif
               break;
           case 2:
               BUFFER_SIZEx0 = BUFFER_SIZEx02;
               p1=cbw_ReadCapacity_02;
               p2=p;
#ifdef DEG34
               sci_printf( "+send_cbw ReadCapacity \n" );
#endif
               break;
           case 3:
               BUFFER_SIZEx0 = BUFFER_SIZEx03;
               p1=cbw_Read10_03;
               p2=p;
#ifdef DEG34
               sci_printf( "+send_cbw Read10 \n" );
#endif
               break;
           case 4:
               BUFFER_SIZEx0 = BUFFER_SIZEx03 * count0;
               p1=cbw_Read10_04;
               p2=dat8;

               uic0.l0=addrs;
               for(i=0;i<4;++i) p1[17+i]=uic0.c0[i];

               p1[23] = count0;

               uic0.l0=BUFFER_SIZEx0;
               for(i=0;i<4;++i) p1[8+i]=uic0.c0[3-i];

#ifdef DEG34
               sci_printf( "+send_cbw Read10(2) \n" );
               sci_printf("addrs =%d,  %x %x %x %x \n", addrs, p1[17],p1[18],p1[19],p1[20]);
               sci_printf("BUFFER_SIZEx0 =%d, %x %x %x %x \n", count0, p1[8],p1[9],p1[10],p1[11]);
               sci_printf("count0= %d, %x \n", count0, p1[23]);
#endif
               break;
            //default:
         }  
          
      

	 

	 /*------ USB bZ[W̑M -----*/ 	 
         #define WAIT_HOST_ACTION_TIME  0x300000
	 l=0; size0=0; i=1;
	 while(1)
         {
	  if( H2F_start_snd(31, p1) == 0) { i=0; break;}
	  if(l>WAIT_HOST_ACTION_TIME ) { break; } else{ ++l; }
	 }
    
         if( i==1) 
#ifdef DEG34
               sci_printf( "-fail H2F_start_snd \n" );
#else
               { rt0=-1;}
#endif
         else
         {	
	   /*------ bZ[W̑M܂ő҂ -----*/
	   l=0; i=0;
	   while( !(H2F_check_complete(BULK_OUT_PIPE)) )
           {	 		 
	    if(l>WAIT_HOST_ACTION_TIME ) { i=1; break; } else{ ++l; }
		/* wait */
	   }	
           if( i==1)  
#ifdef DEG34
                sci_printf( "-fail H2F_check_complete for SEND \n" );
#else 
                {rt0=-2;}
#endif
           else
           {
            /*------ USB f[^̎M Data Phase -----*/ 
           #define WAIT_HOST_ACTION_TIME2  0xf00000
            if(BUFFER_SIZEx0 <= 0) goto skip_recv;
	    l=0; i=1;
            while(1)
            {
	      if( H2F_start_rcv(BUFFER_SIZEx0  ,p2) == 0) { i=0; break;}	  
              if(l > WAIT_HOST_ACTION_TIME2) { break; } else{ ++l;}
	     }	
            if( i==1) 
#ifdef DEG34
                sci_printf( "-fail H2F_start_rcv \n" );
#else
                {rt0=-3;}
#endif
            else
            {
	     /*------ f[^M܂ő҂ -----*/
	     l=0; i=0;
	      while( !(H2F_check_complete(BULK_IN_PIPE)) )
             {
		if(l> WAIT_HOST_ACTION_TIME2) { i=1; break; } 	else{ ++l;}
	      	/* wait */
	     }	
                 if( i==1) 
#ifdef DEG34
                     sci_printf( "-fail H2F_check_complete for RECV \n" );
#else
                     {rt0=-4;}
#endif	
                 else
                 {	 		  
                   size0 = BUFFER_SIZEx0 - USBDataCount[ BULK_IN_PIPE ];
                
                   switch( code0)
                   {
                     case 1:
                       p2[BUFFER_SIZEx0]=0x00;
#ifdef DEG34
                       sci_printf( "size0= %d\n",size0);
#endif
                       sci_printf( "%s\n",&p2[8] );  // from ascii code 
                       break;
                     case 2:
#ifdef DEG34
                       sci_printf( "size0= %d\n",size0);
#endif
                       for(i=0;i<4;++i) uic0.c0[i]=p2[i];
                       s_max_lba=uic0.l0;
#ifdef DEG34
                       sci_printf( "logical Block address = %d\n", uic0.l0);
					   sci_printf( "%x %x %x %x \n", p2[0],p2[1],p2[2],p2[3]);
#endif
                       for(i=0;i<4;++i) uic0.c0[i]=p2[i+4];
                       s_bytes_per_block=uic0.l0;
#ifdef DEG34                    
                       sci_printf( "Block length in bytes= %d\n", uic0.l0);
                       sci_printf( "%x %x %x %x \n", p2[4],p2[5],p2[6],p2[7]);

#endif
                       break;
                   
                     case 3:
#ifdef DEG34
                       sci_printf( "size0= %d\n",size0);
#endif
                       for(i=0;i<4;++i) uic0.c0[3-i]=p2[i+454];
                       s_DbrOffset=uic0.l0;
#ifdef DEG34                    
                       sci_printf( " 1st sector no. BPD = %d\n", uic0.l0);
                       sci_printf( "%x %x %x %x \n", p2[454],p2[455],p2[456],p2[457]);
                       sci_printf( "0x55= %x , 0xAA= %x \n", p2[510],p2[511]);
#endif
                       break;
                     case 4:
#ifdef DEG34
                       sci_printf( "size0= %d\n",size0);
#endif
                        break;
                    //default: 

                   }
          skip_recv:
                   /*------ USB f[^̎M CSW-----*/ 
	           l=0; i=1; p[SIZE_OF_CSW - 1 ]=0x01;
                   while(1)
                   {
	                if( H2F_start_rcv(SIZE_OF_CSW  ,p) == 0) { i=0; break;}	  
                    if(l > WAIT_HOST_ACTION_TIME2) { break; } else{ ++l;}
	               }	
                   if( i==1) 
#ifdef DEG34
                      sci_printf( "-fail H2F_start_rcv for CSW \n" );
#else
                     {rt0=-5;}
#endif
                   else
                   {
	               /*------ f[^M܂ő҂ -----*/
	               l=0; i=0;
	                while( !(H2F_check_complete(BULK_IN_PIPE)) )
                        {
	                	if(l> WAIT_HOST_ACTION_TIME2) { i=1; break; } 	else{ ++l;}
	      	                /* wait */
	                }	
                       if( i==1) 
#ifdef DEG34
                          sci_printf( "-fail H2F_check_complete for RECV csw \n" );
#else
                         {rt0=-6;}
#endif	
                       else
                       {
                           size0 = SIZE_OF_CSW - USBDataCount[ BULK_IN_PIPE ];
                           if( (p[SIZE_OF_CSW - 1 ] == 0x00) && (size0 == SIZE_OF_CSW))
                            {
#ifdef DEG34 
                              sci_printf( "+OK bCSWStatus \n" ); 
#endif
                              return 0;
                            }
                           else 
                            { 
#ifdef DEG34
                              sci_printf( "-Error bCSWStatus %d (size %d)\n", p[SIZE_OF_CSW - 1 ], size0);                            
#endif
                              rt0=-7;

                            }	

                           

                       }
                 }
		}
	 }
        }
        }

        if( rt0 != 0) sci_printf( "-Error code %d , In send_cbw_a\n", rt0 );

          return rt0;
}
