/*""FILE COMMENT""**************************************************************
*
*       System Name : SH7670 USB Sample Program
*       File Name   : h_host_Desc.c
*       Contents    : Host Pipe Difinitions
*       Version     : 2.01.00
*       Model       : M3A-HS71
*       CPU         : SH7670
*       Compiler    : SHC9.1.1.0
*       OS          : none
*
*       note        :
*                     <ӎ>
*                     {TvvOׂ͂ĎQlłA
*                     ̓ۏ؂̂ł͂܂B
*                     {TvvO͂ql̃\tgEGAJ
*                     ZpQlƂĂp
*
*       The information described here may contain technical inaccuracies or
*       typographical errors. Renesas Technology Corporation and Renesas Solutions
*       assume no responsibility for any damage, liability, or other loss rising 
*       from these inaccuracies or errors.
*
*       Copyright (C) 2008 Renesas Technology Corp. All Rights Reserved
*       AND Renesas Solutions Corp. All Rights Reserved
*
*       history   : 2008.01.09 ver.1.00.00 
*                 : 2008.01.17 ver.2.00.00 
*                 : 2008.09.02 ver.2.01.00 
*""FILE COMMENT END""*********************************************************/
#include "..\..\inc\usb_firm.h"
#include "../../../common.h"

/************************************************************************************/
/* Endpoint Configuration Data Format												*/
/************************************************************************************/
/*	LINE1: Pipe Window Select Register												*/
/*		CPU Access PIPE					: PIPE1 to PIPE7			[ ### SET ### ]	*/
/*	LINE2: Pipe Configuration Register												*/
/*		Transfer Type					: USB_NONE					[ USB_NONE    ]	*/
/*		Buffer Ready interrupt			: USB_NONE					[ USB_NONE    ]	*/
/*		Double Buffer Mode				: USB_CNT_ON / USB_CNT_OFF	[ ### SET ### ]	*/
/*		Continuous Transmit:			: USB_CNT_ON / USB_CNT_OFF	[ ### SET ### ]	*/
/*		Short NAK						: USB_NONE					[ USB_NONE    ]	*/
/*		Transfer Direction				: USB_NONE					[ USB_NONE    ]	*/
/*		Endpoint Number					: USB_NONE					[ USB_NONE    ]	*/
/*	LINE3: Pipe Buffer Configuration Register										*/
/*		Buffer Size						: USB_BUF_SIZE(x)			[ ### SET ### ]	*/
/*		Buffer Top Number				: USB_BUF_BUMB(x)			[ ### SET ### ]	*/
/*	LINE4: Pipe Maxpacket Size Register												*/
/*		Max Packet Size					: USB_NONE					[ USB_NONE    ]	*/
/*	LINE5: Pipe Cycle Configuration Register (0x6C)									*/
/*		ISO Buffer Flush Mode			: USB_NONE					[ USB_NONE    ]	*/
/*		ISO Interval Value				: USB_NONE					[ USB_NONE    ]	*/
/*	LINE6: use FIFO port															*/
/*										: USB_CUSE					[ ### SET ### ]	*/
/*										: USB_D0USE / USB_D1USE						*/
/*										: USB_D0DMA	/ USB_D0DMA						*/
/************************************************************************************/

USB_CFG_PIPETBL		VendorDefEPTbl0[ ] = {

/* INOUT́@USB[̒`ԂɈˑ̂ŁAK0ԂOUTɂȂȂ@*/
/* ǂ@ΓɍĂKvB*/
	{
		PIPE1,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDON | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 512 ) | BUF_NUMB( 16 ),
		USB_NONE,
		USB_NONE,
#ifdef FIFO_DMA_OUT 
                D1DMA,
#else
		D1USE,
#endif
	},

	{
		PIPE2,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDON | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 512 ) | BUF_NUMB( 8 ),
		USB_NONE,
		USB_NONE,
#ifdef FIFO_DMA_OUT 
                D0DMA,
#else
		D0USE,
#endif
	},



	{
		PIPE3,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDON | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 512 ) | BUF_NUMB( 24 ),
		USB_NONE,
		USB_NONE,
//		D0USE,
		D0DMA,
	},

	{
		PIPE4,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDON | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 512 ) | BUF_NUMB( 32 ),
		USB_NONE,
		USB_NONE,
//		D0USE,
		D0DMA,
	},

	{
		PIPE5,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDON | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 512 ) | BUF_NUMB( 40 ),
		USB_NONE,
		USB_NONE,
//		D0USE,
		D0DMA,
	},

	{
		PIPE6,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDOFF | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 64 ) | BUF_NUMB( 4 ),
		USB_NONE,
		USB_NONE,
		CUSE,
	},

	{
		PIPE7,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDOFF | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 64 ) | BUF_NUMB( 5 ),
		USB_NONE,
		USB_NONE,
		CUSE,
	},

	{
		PIPE8,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDOFF | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 64 ) | BUF_NUMB( 6 ),
		USB_NONE,
		USB_NONE,
		CUSE,
	},

	{
		PIPE9,
		/* TYPE  / BFRE     / DBLB     / CNTMD  / SHTNAK   / DIR      / EPNUM */
		USB_NONE | USB_NONE | DBLBOFF | CNTMDOFF | USB_NONE | USB_NONE | USB_NONE,
		BUF_SIZE( 64 ) | BUF_NUMB( 7 ),
		USB_NONE,
		USB_NONE,
		CUSE,
	},

	{
		/* Pipe end */
		0xFFFF,
		0xFFFF,
		0xFFFF,
		0xFFFF,
		0xFFFF,
		0xFFFF
	}
};

/*===========================================================================*/
/* End of File */
