/*""FILE COMMENT""**************************************************************
*
*       System Name : SH7670 USB Sample Program
*       File Name   : h_usbdrv_api.c
*       Contents    : Host USB Class Driver
*       Version     : 2.01.00
*       Model       : M3A-HS71
*       CPU         : SH7670
*       Compiler    : SHC9.1.1.0
*       OS          : none
*
*       note        :
*                     <ӎ>
*                     {TvvOׂ͂ĎQlłA
*                     ̓ۏ؂̂ł͂܂B
*                     {TvvO͂ql̃\tgEGAJ
*                     ZpQlƂĂp
*
*       The information described here may contain technical inaccuracies or
*       typographical errors. Renesas Technology Corporation and Renesas Solutions
*       assume no responsibility for any damage, liability, or other loss rising 
*       from these inaccuracies or errors.
*
*       Copyright (C) 2008 Renesas Technology Corp. All Rights Reserved
*       AND Renesas Solutions Corp. All Rights Reserved
*
*       history   : 2008.01.09 ver.1.00.00 
*                 : 2008.01.17 ver.2.00.00 
*                 : 2008.09.02 ver.2.01.00 
*""FILE COMMENT END""*********************************************************/

/******* include file ********************************************************/
#include "..\..\inc\usb.h"

/*""FUNC COMMENT""************************************************************ 
* ID         : 
* Outline    : Get Device Descriptor
*----------------------------------------------------------------------------- 
* Include    : 
*----------------------------------------------------------------------------- 
* Declaration: USB_S16 H_GetDeviceDescriptor(USB_U16 size, USB_U8 *buf);
*----------------------------------------------------------------------------- 
* Function   : 
*            : 
*----------------------------------------------------------------------------- 
* Argument   : USB_U16 size             : size
*            : USB_U8  *buf             : buffer
*----------------------------------------------------------------------------- 
* ReturnValue: void
*----------------------------------------------------------------------------- 
* Notice     : 
*            : 
*""FUNC COMMENT END""*********************************************************/
USB_S16 H_GetDeviceDescriptor( USB_U16 size, USB_U8 *buf)
{
	USB_S16		ret;

	ret = H_CtrlTransfer( 0x0680, 0x0100, 0x0000, size, buf);

	return ret;
}

/*""FUNC COMMENT""************************************************************ 
* ID         : 
* Outline    : Get Configration Descriptor
*----------------------------------------------------------------------------- 
* Include    : 
*----------------------------------------------------------------------------- 
* Declaration: USB_S16 H_GetConfigDescriptor(USB_U16 size, USB_U8 *buf);
*----------------------------------------------------------------------------- 
* Function   : 
*            : 
*----------------------------------------------------------------------------- 
* Argument   : USB_U16 size             : size
*            : USB_U8  *buf             : buffer
*----------------------------------------------------------------------------- 
* ReturnValue: void
*----------------------------------------------------------------------------- 
* Notice     : 
*            : 
*""FUNC COMMENT END""*********************************************************/
USB_S16 H_GetConfigDescriptor( USB_U16 size, USB_U8 *buf)
{
	USB_S16		ret;

	ret = H_CtrlTransfer( 0x0680, 0x0200, 0x0000, size, buf);

	return ret;
}

/*===========================================================================*/
/* End of File */
